"""
Authors: Peter Mawhorter
Consulted:
Date: 2022-1-29
Purpose: Test for the Diamonds task: draw a diamond pattern using
functions and a limited number of print function calls.
"""

# Import our testing library
import optimism

# Import your code
import diamonds

# Note: there are many possible correct outputs, because you are allowed
# to have extra spaces at the end of lines. Optimism should ignore any
# white-space at the end of a line, so regardless of whether your
# solution includes end-of-line spaces, it should pass this test.

# We set up a manager to do tests of the diamondPattern function
manager = optimism.testFunction(diamonds.diamondPattern)

# Here is our only test
manager.case().checkPrintedLines(
'  1         1         1         1  ',
' 2 2       2 2       2 2       2 2 ',
'3 3 3     3 3 3     3 3 3     3 3 3',
' 2 2       2 2       2 2       2 2 ',
'  1         1         1         1  ',
'       1         1         1         1  ',
'      2 2       2 2       2 2       2 2 ',
'     3 3 3     3 3 3     3 3 3     3 3 3',
'      2 2       2 2       2 2       2 2 ',
'       1         1         1         1  ',
'  1         1         1         1  ',
' 2 2       2 2       2 2       2 2 ',
'3 3 3     3 3 3     3 3 3     3 3 3',
' 2 2       2 2       2 2       2 2 ',
'  1         1         1         1  ',
'       1         1         1         1  ',
'      2 2       2 2       2 2       2 2 ',
'     3 3 3     3 3 3     3 3 3     3 3 3',
'      2 2       2 2       2 2       2 2 ',
'       1         1         1         1  ',
'  1         1         1         1  ',
' 2 2       2 2       2 2       2 2 ',
'3 3 3     3 3 3     3 3 3     3 3 3',
' 2 2       2 2       2 2       2 2 ',
'  1         1         1         1  ',
'       1         1         1         1  ',
'      2 2       2 2       2 2       2 2 ',
'     3 3 3     3 3 3     3 3 3     3 3 3',
'      2 2       2 2       2 2       2 2 ',
'       1         1         1         1  ',
'  1         1         1         1  ',
' 2 2       2 2       2 2       2 2 ',
'3 3 3     3 3 3     3 3 3     3 3 3',
' 2 2       2 2       2 2       2 2 ',
'  1         1         1         1  ',
'       1         1         1         1  ',
'      2 2       2 2       2 2       2 2 ',
'     3 3 3     3 3 3     3 3 3     3 3 3',
'      2 2       2 2       2 2       2 2 ',
'       1         1         1         1  '
)
